function [distance_val model_momm]=distance_function(distance_param,data_momm,wtmat)


global changes_names changes_vec

changes_vec = distance_param;

global M_ oo_
sigma_eps_a = distance_param(1);
sigma_eps_isp = distance_param(2);    
sigma_eps_tau = distance_param(3);
rho_a = distance_param(4);
rho_isp = distance_param(5);
rho_taup = distance_param(6);
psip_i = distance_param(7);
kappap = distance_param(8);



if (rho_isp<0.99 && rho_isp>0 && ...
    rho_taup<.9 && rho_taup>0 && ...
    rho_a<.99 && rho_a >0 &&...
    psip_i>0 &&...
    kappap>0 && kappap<.95 &&...
    sigma_eps_isp > 0.000001 && sigma_eps_tau>0.000001 && sigma_eps_a>0.000001  )


try


nperiods = 2000;
irf_shock = char('eps_a','eps_isp','eps_tau');
randn('seed',1); 
nshocks = size(irf_shock,1);
shockssequence = randn(nperiods,nshocks);

[zdatalinear, zdatass, oobase_, Mbase_ ] = ...
     solve_no_constraint_no_parse(shockssequence,irf_shock,nperiods);
 
ytot_pos = strmatch('ytot',Mbase_.endo_names,'exact');
ginvest_pos = strmatch('ginvest',Mbase_.endo_names,'exact');
q_pos = strmatch('q',Mbase_.endo_names,'exact');
%r_e_pos = strmatch('r_e',Mbase_.endo_names,'exact');

f0_ytot_data = zdatalinear(:,ytot_pos);
f0_ytot_ss = zdatass(ytot_pos);
f0_ginvest_data = zdatalinear(:,ginvest_pos);
f0_ginvest_ss = zdatass(ginvest_pos);
f0_q_data = zdatalinear(:,q_pos);
%f0_r_e_data = zdatalinear(:,r_e_pos);

%dow =100*bpass(f0_r_e_data,6,32);
gdp = 100*bpass(f0_ytot_data/f0_ytot_ss,6,32);
investment = 100*bpass(f0_ginvest_data/f0_ginvest_ss,6,32);
investment_price = 100*bpass(f0_q_data,6,32);

model_dataset = [gdp, investment, investment_price];

optwt = 0; % no weighting function computed
[model_momm] = wtm_rm_noskew_opt(model_dataset,optwt);


distance_val = (model_momm-data_momm)'*wtmat*(model_momm-data_momm);
catch
model_momm = nan;
distance_val = 100000;   
end

else
model_momm = nan;
distance_val = 100000;
end


% for debugging, if needed

% var_labels =char('Dow','GDP','Investment','Investment Price');
% 
% nvars = size(var_labels,1);
% 
% 
% this_mom = 0;
% for i = 1:nvars
%     for j=i:nvars
%         this_mom = this_mom+1;
%     if i == j 
%         display(['Variance of ',deblank(var_labels(i,:)),' in the model is ',num2str(model_momm(this_mom)*10000),' and in the data is ',num2str(data_momm(this_mom)*10000)]) 
%     else
%         display(['The covariance of ',deblank(var_labels(i,:)),' witb ',deblank(var_labels(j,:)),' in the model is ',num2str(model_momm(this_mom)),' and in the data is ',num2str(data_momm(this_mom))]) 
%  
%     end
%     end
% end
% 
